import Vue from 'vue'
import { firebase } from 'boot/config'
import {showErrorMessage} from 'src/functions/function-show-error-message'


const state = {
	countries:{},
	countryCodes:{
		"AD" : "Andorra",
		"AE" : "United Arab Emirates",
		"AF" : "Afghanistan",
		"AG" : "Antigua and Barbuda",
		"AI" : "Anguilla",
		"AL" : "Albania",
		"AM" : "Armenia",
		"AN" : "Netherlands Antilles",
		"AO" : "Angola",
		"AQ" : "Antarctica",
		"AR" : "Argentina",
		"AS" : "American Samoa",
		"AT" : "Austria",
		"AU" : "Australia",
		"AW" : "Aruba",
		"AX" : "Åland Islands",
		"AZ" : "Azerbaijan",
		"BA" : "Bosnia and Herzegovina",
		"BB" : "Barbados",
		"BD" : "Bangladesh",
		"BE" : "Belgium",
		"BF" : "Burkina Faso",
		"BG" : "Bulgaria",
		"BH" : "Bahrain",
		"BI" : "Burundi",
		"BJ" : "Benin",
		"BM" : "Bermuda",
		"BN" : "Brunei",
		"BO" : "Bolivia",
		"BR" : "Brazil",
		"BS" : "Bahamas",
		"BT" : "Bhutan",
		"BV" : "Bouvet Island",
		"BW" : "Botswana",
		"BY" : "Belarus",
		"BZ" : "Belize",
		"CA" : "Canada",
		"CC" : "Cocos (Keeling) Islands",
		"CD" : "Congo, Democratic Republic",
		"CF" : "Central African Republic",
		"CG" : "Congo, Republic",
		"CH" : "Switzerland",
		"CI" : "Cote d'Ivoire",
		"CK" : "Cook Islands",
		"CL" : "Chile",
		"CM" : "Cameroon",
		"CN" : "China",
		"CO" : "Colombia",
		"CR" : "Costa Rica",
		"CU" : "Cuba",
		"CV" : "Cape Verde",
		"CX" : "Christmas Island",
		"CY" : "Cyprus",
		"CZ" : "Czech Republic",
		"DE" : "Germany",
		"DJ" : "Djibouti",
		"DK" : "Denmark",
		"DM" : "Dominica",
		"DO" : "Dominican Republic",
		"DZ" : "Algeria",
		"EC" : "Ecuador",
		"EE" : "Estonia",
		"EG" : "Egypt",
		"EH" : "Western Sahara",
		"ER" : "Eritrea",
		"ES" : "Spain",
		"ET" : "Ethiopia",
		"FI" : "Finland",
		"FJ" : "Fiji",
		"FK" : "Falkland Islands (Malvinas)",
		"FM" : "Micronesia, Federated States of",
		"FO" : "Faroe Islands",
		"FR" : "France",
		"GA" : "Gabon",
		"GB" : "United Kingdom",
		"GD" : "Grenada",
		"GE" : "Georgia",
		"GF" : "French Guiana",
		"GG" : "Guernsey",
		"GH" : "Ghana",
		"GI" : "Gibraltar",
		"GL" : "Greenland",
		"GM" : "Gambia",
		"GN" : "Guinea",
		"GP" : "Guadeloupe",
		"GQ" : "Equatorial Guinea",
		"GR" : "Greece",
		"GS" : "South Georgia and the South Sandwich Islands",
		"GT" : "Guatemala",
		"GU" : "Guam",
		"GW" : "Guinea-Bissau",
		"GY" : "Guyana",
		"HK" : "Hong Kong",
		"HM" : "Heard Island and Mcdonald Islands",
		"HN" : "Honduras",
		"HR" : "Croatia",
		"HT" : "Haiti",
		"HU" : "Hungary",
		"ID" : "Indonesia",
		"IE" : "Ireland",
		"IL" : "Israel",
		"IM" : "Isle of Man",
		"IN" : "India",
		"IO" : "British Indian Ocean Territory",
		"IQ" : "Iraq",
		"IR" : "Iran",
		"IS" : "Iceland",
		"IT" : "Italy",
		"JE" : "Jersey",
		"JM" : "Jamaica",
		"JO" : "Jordan",
		"JP" : "Japan",
		"KE" : "Kenya",
		"KG" : "Kyrgyzstan",
		"KH" : "Cambodia",
		"KI" : "Kiribati",
		"KM" : "Comoros",
		"KN" : "Saint Kitts and Nevis",
		"KP" : "North Korea",
		"KR" : "South Korea",
		"KW" : "Kuwait",
		"KY" : "Cayman Islands",
		"KZ" : "Kazakhstan",
		"LA" : "Laos",
		"LB" : "Lebanon",
		"LC" : "Saint Lucia",
		"LI" : "Liechtenstein",
		"LK" : "Sri Lanka",
		"LR" : "Liberia",
		"LS" : "Lesotho",
		"LT" : "Lithuania",
		"LU" : "Luxembourg",
		"LV" : "Latvia",
		"LY" : "Libya",
		"MA" : "Morocco",
		"MC" : "Monaco",
		"MD" : "Moldova",
		"ME" : "Montenegro",
		"MG" : "Madagascar",
		"MH" : "Marshall Islands",
		"MK" : "Macedonia",
		"ML" : "Mali",
		"MM" : "Myanmar",
		"MN" : "Mongolia",
		"MO" : "Macau",
		"MP" : "Northern Mariana Islands",
		"MQ" : "Martinique",
		"MR" : "Mauritania",
		"MS" : "Montserrat",
		"MT" : "Malta",
		"MU" : "Mauritius",
		"MV" : "Maldives",
		"MW" : "Malawi",
		"MX" : "Mexico",
		"MY" : "Malaysia",
		"MZ" : "Mozambique",
		"NA" : "Namibia",
		"NC" : "New Caledonia",
		"NE" : "Niger",
		"NF" : "Norfolk Island",
		"NG" : "Nigeria",
		"NI" : "Nicaragua",
		"NL" : "Netherlands",
		"NO" : "Norway",
		"NP" : "Nepal",
		"NR" : "Nauru",
		"NU" : "Niue",
		"NZ" : "New Zealand",
		"OM" : "Oman",
		"PA" : "Panama",
		"PE" : "Peru",
		"PF" : "French Polynesia",
		"PG" : "Papua New Guinea",
		"PH" : "Philippines",
		"PK" : "Pakistan",
		"PL" : "Poland",
		"PM" : "Saint Pierre and Miquelon",
		"PN" : "Pitcairn",
		"PR" : "Puerto Rico",
		"PS" : "Palestine",
		"PT" : "Portugal",
		"PW" : "Palau",
		"PY" : "Paraguay",
		"QA" : "Qatar",
		"RE" : "Reunion",
		"RO" : "Romania",
		"RS" : "Serbia",
		"RU" : "Russia",
		"RW" : "Rwanda",
		"SA" : "Saudi Arabia",
		"SB" : "Solomon Islands",
		"SC" : "Seychelles",
		"SD" : "Sudan",
		"SS" : "South Sudan",
		"SE" : "Sweden",
		"SG" : "Singapore",
		"SH" : "Saint Helena",
		"SI" : "Slovenia",
		"SJ" : "Svalbard and Jan Mayen",
		"SK" : "Slovakia",
		"SL" : "Sierra Leone",
		"SM" : "San Marino",
		"SN" : "Senegal",
		"SO" : "Somalia",
		"SR" : "Suriname",
		"ST" : "Sao Tome and Principe",
		"SV" : "El Salvador",
		"SX" : "Sint Maarten",
		"SY" : "Syria",
		"SZ" : "Swaziland",
		"TC" : "Turks and Caicos Islands",
		"TD" : "Chad",
		"TF" : "French Southern Territories",
		"TG" : "Togo",
		"TH" : "Thailand",
		"TJ" : "Tajikistan",
		"TK" : "Tokelau",
		"TL" : "East Timor",
		"TM" : "Turkmenistan",
		"TN" : "Tunisia",
		"TO" : "Tonga",
		"TR" : "Turkey",
		"TT" : "Trinidad and Tobago",
		"TV" : "Tuvalu",
		"TW" : "Taiwan",
		"TZ" : "Tanzania",
		"UA" : "Ukraine",
		"UG" : "Uganda",
		"UM" : "United States Minor Outlying Islands",
		"US" : "United States of America",
		"UY" : "Uruguay",
		"UZ" : "Uzbekistan",
		"VA" : "Vatican City",
		"VC" : "Saint Vincent and the Grenadines",
		"VE" : "Venezuela",
		"VG" : "Virgin Islands, British",
		"VI" : "Virgin Islands, U.S.",
		"VN" : "Vietnam",
		"VU" : "Vanuatu",
		"WF" : "Wallis and Futuna",
		"WS" : "Samoa",
		"XK" : "Kosovo",
		"YE" : "Yemen",
		"YT" : "Mayotte",
		"ZA" : "South Africa",
		"ZM" : "Zambia",
		"ZW" : "Zimbabwe"
	},
	countryCodes_rev:{
		"Afghanistan" : "AF",
		"Albania" : "AL",
		"Algeria" : "DZ",
		"American Samoa" : "AS",
		"Andorra" : "AD",
		"Angola" : "AO",
		"Anguilla" : "AI",
		"Antarctica" : "AQ",
		"Antigua and Barbuda" : "AG",
		"Argentina" : "AR",
		"Armenia" : "AM",
		"Aruba" : "AW",
		"Australia" : "AU",
		"Austria" : "AT",
		"Azerbaijan" : "AZ",
		"Bahamas" : "BS",
		"Bahrain" : "BH",
		"Bangladesh" : "BD",
		"Barbados" : "BB",
		"Belarus" : "BY",
		"Belgium" : "BE",
		"Belize" : "BZ",
		"Benin" : "BJ",
		"Bermuda" : "BM",
		"Bhutan" : "BT",
		"Bolivia" : "BO",
		"Bosnia and Herzegovina" : "BA",
		"Botswana" : "BW",
		"Bouvet Island" : "BV",
		"Brazil" : "BR",
		"British Indian Ocean Territory" : "IO",
		"Brunei" : "BN",
		"Bulgaria" : "BG",
		"Burkina Faso" : "BF",
		"Burundi" : "BI",
		"Cambodia" : "KH",
		"Cameroon" : "CM",
		"Canada" : "CA",
		"Cape Verde" : "CV",
		"Cayman Islands" : "KY",
		"Central African Republic" : "CF",
		"Chad" : "TD",
		"Chile" : "CL",
		"China" : "CN",
		"Christmas Island" : "CX",
		"Cocos (Keeling) Islands" : "CC",
		"Colombia" : "CO",
		"Comoros" : "KM",
		"Congo, Republic" : "CG",
		"Congo, Democratic Republic" : "CD",
		"Cook Islands" : "CK",
		"Costa Rica" : "CR",
		"Cote d'Ivoire" : "CI",
		"Croatia" : "HR",
		"Cuba" : "CU",
		"Cyprus" : "CY",
		"Czech Republic" : "CZ",
		"Denmark" : "DK",
		"Djibouti" : "DJ",
		"Dominica" : "DM",
		"Dominican Republic" : "DO",
		"Ecuador" : "EC",
		"Egypt" : "EG",
		"El Salvador" : "SV",
		"Equatorial Guinea" : "GQ",
		"Eritrea" : "ER",
		"Estonia" : "EE",
		"Ethiopia" : "ET",
		"Falkland Islands (Malvinas)" : "FK",
		"Faroe Islands" : "FO",
		"Fiji" : "FJ",
		"Finland" : "FI",
		"France" : "FR",
		"French Guiana" : "GF",
		"French Polynesia" : "PF",
		"French Southern Territories" : "TF",
		"Gabon" : "GA",
		"Gambia" : "GM",
		"Georgia" : "GE",
		"Germany" : "DE",
		"Ghana" : "GH",
		"Gibraltar" : "GI",
		"Greece" : "GR",
		"Greenland" : "GL",
		"Grenada" : "GD",
		"Guadeloupe" : "GP",
		"Guam" : "GU",
		"Guatemala" : "GT",
		"Guernsey" : "GG",
		"Guinea" : "GN",
		"Guinea-Bissau" : "GW",
		"Guyana" : "GY",
		"Haiti" : "HT",
		"Heard Island and Mcdonald Islands" : "HM",
		"Vatican City" : "VA",
		"Honduras" : "HN",
		"Hong Kong" : "HK",
		"Hungary" : "HU",
		"Iceland" : "IS",
		"India" : "IN",
		"Indonesia" : "ID",
		"Iran" : "IR",
		"Iraq" : "IQ",
		"Ireland" : "IE",
		"Isle of Man" : "IM",
		"Israel" : "IL",
		"Italy" : "IT",
		"Jamaica" : "JM",
		"Japan" : "JP",
		"Jersey" : "JE",
		"Jordan" : "JO",
		"Kazakhstan" : "KZ",
		"Kenya" : "KE",
		"Kiribati" : "KI",
		"North Korea" : "KP",
		"South Korea" : "KR",
		"Kosovo" : "XK",
		"Kuwait" : "KW",
		"Kyrgyzstan" : "KG",
		"Laos" : "LA",
		"Latvia" : "LV",
		"Lebanon" : "LB",
		"Lesotho" : "LS",
		"Liberia" : "LR",
		"Libya" : "LY",
		"Liechtenstein" : "LI",
		"Lithuania" : "LT",
		"Luxembourg" : "LU",
		"Macau" : "MO",
		"Macedonia" : "MK",
		"Madagascar" : "MG",
		"Malawi" : "MW",
		"Malaysia" : "MY",
		"Maldives" : "MV",
		"Mali" : "ML",
		"Malta" : "MT",
		"Marshall Islands" : "MH",
		"Martinique" : "MQ",
		"Mauritania" : "MR",
		"Mauritius" : "MU",
		"Mexico" : "MX",
		"Micronesia" : "FM",
		"Moldova" : "MD",
		"Monaco" : "MC",
		"Mongolia" : "MN",
		"Montenegro" : "ME",
		"Montserrat" : "MS",
		"Morocco" : "MA",
		"Mozambique" : "MZ",
		"Myanmar" : "MM",
		"Namibia" : "NA",
		"Nauru" : "NR",
		"Nepal" : "NP",
		"Netherlands" : "NL",
		"Netherlands Antilles" : "AN",
		"New Caledonia" : "NC",
		"New Zealand" : "NZ",
		"Nicaragua" : "NI",
		"Niger" : "NE",
		"Nigeria" : "NG",
		"Niue" : "NU",
		"Norfolk Island" : "NF",
		"Northern Mariana Islands" : "MP",
		"Norway" : "NO",
		"Oman" : "OM",
		"Pakistan" : "PK",
		"Palau" : "PW",
		"Palestine" : "PS",
		"Panama" : "PA",
		"Papua New Guinea" : "PG",
		"Paraguay" : "PY",
		"Peru" : "PE",
		"Philippines" : "PH",
		"Pitcairn" : "PN",
		"Poland" : "PL",
		"Portugal" : "PT",
		"Puerto Rico" : "PR",
		"Qatar" : "QA",
		"Rwanda" : "RW",
		"Reunion" : "RE",
		"Romania" : "RO",
		"Russia" : "RU",
		"Samoa" : "WS",
		"Saint Helena" : "SH",
		"Saint Kitts and Nevis" : "KN",
		"Saint Lucia" : "LC",
		"Saint Pierre and Miquelon" : "PM",
		"Saint Vincent and the Grenadines" : "VC",
		"San Marino" : "SM",
		"Sao Tome and Principe" : "ST",
		"Saudi Arabia" : "SA",
		"Senegal" : "SN",
		"Serbia" : "RS",
		"Seychelles" : "SC",
		"Sierra Leone" : "SL",
		"Singapore" : "SG",
		"Sint Maarten" : "SX",
		"Slovakia" : "SK",
		"Slovenia" : "SI",
		"Solomon Islands" : "SB",
		"Somalia" : "SO",
		"South Africa" : "ZA",
		"South Georgia and the South Sandwich Islands" : "GS",
		"Spain" : "ES",
		"Sri Lanka" : "LK",
		"Sudan" : "SD",
		"South Sudan" : "SS",
		"Suriname" : "SR",
		"Svalbard and Jan Mayen" : "SJ",
		"Swaziland" : "SZ",
		"Sweden" : "SE",
		"Switzerland" : "CH",
		"Syria" : "SY",
		"Taiwan" : "TW",
		"Tajikistan" : "TJ",
		"Tanzania" : "TZ",
		"Thailand" : "TH",
		"East Timor" : "TL",
		"Togo" : "TG",
		"Tokelau" : "TK",
		"Tonga" : "TO",
		"Trinidad and Tobago" : "TT",
		"Tunisia" : "TN",
		"Turkey" : "TR",
		"Turkmenistan" : "TM",
		"Turks and Caicos Islands" : "TC",
		"Tuvalu" : "TV",
		"Uganda" : "UG",
		"Ukraine" : "UA",
		"United Arab Emirates" : "AE",
		"United Kingdom" : "GB",
		"United States of America" : "US",
		"United States Minor Outlying Islands" : "UM",
		"Uruguay" : "UY",
		"Uzbekistan" : "UZ",
		"Venezuela" : "VE",
		"Vanuatu" : "VU",
		"Vietnam" : "VN",
		"Virgin Islands, British" : "VG",
		"Western Sahara" : "EH",
		"Åland Islands" : "AX",
		"Yemen" : "YE",
		"Zambia" : "ZM",
		"Zimbabwe" : "ZW"
	},
	search: '',

	whatsappgroups:{
		africa1:{name:'West Africa', link:'https://chat.whatsapp.com/GWfNH4Jk7nnJzSF1ZJBghO'},
		africa2:{name:'East Africa', link:'https://chat.whatsapp.com/Ks1O8OSBaoFAxgzmJsXEQX'},
		middleEast:{name:'Middle East', link:'https://chat.whatsapp.com/KlmFjR8cbEl2oTqxBjAvm1'},
		cnAsia:{name:'Central & North Asia', link:'https://chat.whatsapp.com/KFPOAcBzNd9LnLHBpEf0S5'},
		seAsia:{name:'South East Asia', link:'https://chat.whatsapp.com/KSnACNW1N2gJzyCg34volO'},
		oceania:{name:'Oceania', link:'https://chat.whatsapp.com/KuTZdaERWYk9x7SErsQMJr'},
		nAmerica:{name:'North America', link:'https://chat.whatsapp.com/LZY4a9oPVu3Jr8bRbV1yqy'},
		sAmerica:{name:'South America', link:'https://chat.whatsapp.com/Km3UpBk5Cvc66GarXoaFlm'},
		europe:{name:'Europe', link:'https://chat.whatsapp.com/ITxb9OzZHBhGHNCXK9wK3r'},
	  },

	continentAdapter:{
		'Australia & New Zealand':{continent:'Oceania', whatsappgroups:['oceania']},
		'Melanesia':{continent:'Oceania',whatsappgroups:['oceania']},
		'Micronesia':{continent:'Oceania',whatsappgroups:['oceania']},
		'Polynesia':{continent:'Oceania',whatsappgroups:['oceania']},

		'Caribbean':{continent:'North America',whatsappgroups:['nAmerica','sAmerica']},
		'Central America':{continent:'North America',whatsappgroups:['nAmerica','sAmerica']},
		'Northern America':{continent:'North America',whatsappgroups:['nAmerica']},
		'South America':{continent:'South America',whatsappgroups:['sAmerica']},

		'Central Asia':{continent:'Asia',whatsappgroups:['cnAsia']},
		'Eastern Asia':{continent:'Asia',whatsappgroups:['seAsia']},
		'Western Asia':{continent:'Asia',whatsappgroups:['middleEast']},
		'Southern Asia':{continent:'Asia',whatsappgroups:['seAsia']},
		'South-Eastern Asia':{continent:'Asia',whatsappgroups:['seAsia']},

		'Eastern Africa':{continent:'Africa',whatsappgroups:['africa2']},
		'Middle Africa':{continent:'Africa',whatsappgroups:['africa1','africa2']},
		'Northern Africa':{continent:'Africa',whatsappgroups:['africa1','africa2']},
		'Western Africa':{continent:'Africa',whatsappgroups:['africa1']},
		'Southern Africa':{continent:'Africa',whatsappgroups:['africa1','africa2']},

		'Eastern Europe':{continent:'Europe',whatsappgroups:['europe']},
		'Northern Europe':{continent:'Europe',whatsappgroups:['europe']},
		'Western Europe':{continent:'Europe',whatsappgroups:['europe']},
		'Southern Europe':{continent:'Europe',whatsappgroups:['europe']},
	}
}

const mutations = {
	addCountry(state, payload) {
		Vue.set(state.countries, payload.countryKey, payload.countryDetails)
	},
	updateCountry(state, payload) {
		Object.assign(state.countries[payload.countryKey], payload.countryDetails)
	},
	setSearch(state, value) {
		state.search = value
	},
	
}

const actions = {
	setSearch({ commit }, value) {
		commit('setSearch', value)
	},
	
	firebasegetCountries({ commit }) {
		firebase.db.ref('countries/').on('child_added', snapshot => {
			let countryDetails = snapshot.val()
			let countryKey = snapshot.key
			commit('addCountry', {
				countryKey,
				countryDetails
			})
		})
		firebase.db.ref('countries/').on('child_changed', snapshot => {
			let countryDetails = snapshot.val()
			let countryKey = snapshot.key
			commit('updateCountry', {
				countryKey,
				countryDetails
			})
		})
	},
}

const getters = {
	
	countries:(state)=>{
        return state.countries
	},

	
	countriesFiltered: (state, getters) => {
		let countriesSorted = getters.countries,
			countriesFiltered = {}

		if (state.search) {
			Object.keys(countriesSorted).forEach((key)=> {
				let country = countriesSorted[key]
				let countryName=country.name.toLowerCase()
				let searchstring=state.search.toLowerCase()
				let valid = countryName.includes(searchstring)
				if (valid) {
				countriesFiltered[key] = country

				}
			})
			return countriesFiltered		
		}
		return state.countries
	},
	countriesAll: (state, getters) => {
		
		let countriesFiltered = getters.countriesFiltered

		let countries = {}
		Object.keys(countriesFiltered).forEach(function(key) {
			let country = countriesFiltered[key]
			if (countries.name) {
				countries[key] = task
			}
			countries[key] = country
			
		})

		return countries
	},
	
}

export default {
	namespaced: true,
	state,
	mutations,
	actions,
	getters
}